<?php
namespace Webshop\Options;

use Webshop\Options\Service\OptionManagerInterface;

/**
 * Objekti koji imaju postavke.
 *
 * @package Webshop\Options
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/webshop-options
 */
interface OptionsAwareInterface
{
    /**
     * Vraća vrijednost postavke s datim imenom.
     *
     * @param string $name
     * @param null $default
     * @return mixed
     */
    public function getOption(string $name, $default = null);

    /**
     * Postavlja vrijednost postavke s datim imenom.
     *
     * @param string $name
     * @param $value
     */
    public function setOption(string $name, $value): void;

    /**
     * Briše postavku.
     *
     * @param string $name
     */
    public function removeOption(string $name): void;

    /**
     * @return OptionManagerInterface
     */
    public function getOptionManager(): OptionManagerInterface;

    /**
     * @param OptionManagerInterface $optionManager
     */
    public function setOptionManager(OptionManagerInterface $optionManager): void;
}